Lilo gets installed on dist-upgrades, due to the kernel image recommending it. Is this intentional?

Bug #314004 reported by Sarah Kowalik on 2009-01-05
36
This bug affects 5 people
Affects Status Importance Assigned to Milestone
Release Notes for Ubuntu
Undecided
Colin Watson
linux (Ubuntu)
Medium
Andy Whitcroft
Jaunty
Medium
Andy Whitcroft
ubiquity (Ubuntu)
Critical
Colin Watson
Jaunty
Critical
Colin Watson
update-manager (Ubuntu)
High
Michael Vogt
Jaunty
High
Michael Vogt

Bug Description

Lilo gets installed on dist-upgrades, due to the kernel image recommending it. Is this intentional? It would seem odd to have two bootloaders installed on dist-upgrades, effectively by default.

NOTE: that actually lilo was not installed on dist-upgrade but mearly upgraded. However lilo was not expected to be installed and therefore was not expected to be updated when the upgrade was performed.

Package: linux-image-2.6.28-4-generic
Priority: optional
Section: base
Installed-Size: 92196
Maintainer: Ubuntu Kernel Team <email address hidden>
Architecture: i386
Source: linux
Version: 2.6.28-4.6
Provides: fuse-module, ivtv-modules, kvm-api-4, linux-image, linux-image-2.6, ndiswrapper-modules-1.9, redhat-cluster-modules
Depends: initramfs-tools (>= 0.36ubuntu6), coreutils | fileutils (>= 4.0), module-init-tools (>= 3.3-pre11-4ubuntu3)
Pre-Depends: dpkg (>= 1.10.24)
Recommends: lilo (>= 19.1) | grub
Suggests: fdutils, linux-doc-2.6.28 | linux-source-2.6.28
Conflicts: hotplug (<< 0.0.20040105-1)
Filename: pool/main/l/linux/linux-image-2.6.28-4-generic_2.6.28-4.6_i386.deb
Size: 23775268
MD5sum: a88e826290466b452b8259b99aecb3c1
SHA1: 154b7912b272e1655d989cf479a2db5aadb92c50
SHA256: dceeac31badc318666f0eb2be271436b3b3b91430e537cfa7d12e443c209aeb8
Description: Linux kernel image for version 2.6.28 on x86/x86_64
 This package contains the Linux kernel image for version 2.6.28 on
 x86/x86_64.
 .
 Also includes the corresponding System.map file, the modules built by the
 packager, and scripts that try to ensure that the system is not left in an
 unbootable state after an update.
 .
 Supports Generic processors.
 .
 Geared toward desktop systems.
 .
 You likely do not want to install this package directly. Instead, install
 the linux-generic meta-package, which will ensure that upgrades work
 correctly, and that supporting packages are also installed.
Bugs: mailto:<email address hidden>
Origin: Ubuntu

Changed in linux:
importance: Undecided → Medium
status: New → Triaged
Andy Whitcroft (apw) wrote :

Talked to Hobsee a little about this on IRC. It seems that they are finding both lilo and grub installed and seeing lilo updated as they upgrade to Jaunty. I have had a look at the control files in both Intrepid and Jaunty and it is not at all clear that they are asking for this behaviour at all.

Indeed, I have two clean Intrepid installs locally one on 32bit and one on 64 bit. On the 32bit install both lilo and grub are installed, on the 64bit install only grub is installed. According to the installer logs in /var/log/apt, it appears that they were both installed during the original install.

I am not sure why one has both and the other none, though I do note the problem install is also 32bit.

Andy Whitcroft (apw) on 2009-01-07
Changed in linux:
assignee: nobody → apw
status: Triaged → In Progress
Colin Watson (cjwatson) wrote :

Andy's working install was an upgrade from hardy, and so not affected by this bug.

<cjwatson> so it's true that the order of the kernel recommends is what caused this, but really, accident ...
<cjwatson> let me give you a potted summary of what happened, then
<cjwatson> in intrepid, we enabled recommends by default; this had some speedbumps but largely appeared to be working OK
<cjwatson> (therefore any installs from earlier than intrepid are entirely unaffected by this)
<cjwatson> the alternate/server CD (d-i) installs as I described above, by explicitly choosing whether to install grub or lilo depending on installation parameters; no problem there
<cjwatson> however, the desktop installer works quite differently
<cjwatson> we put a "live filesystem" onto the desktop CD, a preinstalled filesystem image with lots of packages on it that's then copied to the target system
<cjwatson> obviously, there are some things on this image that shouldn't end up on the target system, such as the installer itself
<cjwatson> so we copy the filesystem image file-by-file, and then remove unwanted packages using apt (this is still a lot quicker than installing them all from scratch, and allows us to fit an installable live system onto a single CD)
<cjwatson> the set of packages we remove is computed by taking the set-difference between a "desktop install" and the full live filesystem package list, plus one or two other tweaks
<cjwatson> (things like language packs, removing unused kernels if there's more than one available, etc.)
<cjwatson> for various reasons, the script that builds the live filesystem (in the livecd-rootfs package) installs the kernel before it says "right, that's it, what I've got now is a desktop install"
<cjwatson> and, due to the kernel's Recommends, the bootloader (in this case lilo) is considered as part of the desktop install, and not removed by the installer
<cjwatson> the installer notices that it needs grub, and therefore arranges for it to stay installed as well
<cjwatson> and voila, two bootloaders
<cjwatson> I recommend three fixes for this, and will update the bug accordingly:
<cjwatson> 1) ubiquity should arrange to remove all bootloaders except for the one it's installing
<cjwatson> 2) linux should switch the order of its recommends to suit the modern age (not required given 1, but probably sensible anyway, and I think there may well be other bugs about this)
<cjwatson> 3) update-manager should clean up this mess on upgrade

Changed in ubiquity:
assignee: nobody → kamion
importance: Undecided → Critical
milestone: none → jaunty-alpha-3
status: New → Triaged
Changed in update-manager:
assignee: nobody → mvo
importance: Undecided → High
milestone: none → ubuntu-9.04-beta
status: New → Triaged
Colin Watson (cjwatson) on 2009-01-07
Changed in ubiquity:
status: Triaged → Fix Committed
Andy Whitcroft (apw) on 2009-01-07
description: updated
Andy Whitcroft (apw) on 2009-01-07
Changed in linux:
milestone: none → jaunty-alpha-3
status: In Progress → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package ubiquity - 1.11.2

---------------
ubiquity (1.11.2) jaunty; urgency=low

  * Adjust for changes in tzsetup 1:0.24ubuntu1.
  * Correct Bazaar link in debian/copyright (pointed out by shirish).
  * Make sure that only one of grub and lilo is installed (LP: #314004).
  * Add ext4 support (LP: #293465).
  * Automatic update of included source packages: apt-setup 1:0.37ubuntu7,
    hw-detect 1.71ubuntu3, partconf 1.30build1, partman-auto 83ubuntu2,
    partman-base 128ubuntu4, partman-ext3 55ubuntu2, partman-partitioning
    64ubuntu2, partman-target 58ubuntu2, tzsetup 1:0.24ubuntu1, user-setup
    1.23ubuntu6.

 -- Colin Watson <email address hidden> Thu, 08 Jan 2009 18:40:19 +0000

Changed in ubiquity:
status: Fix Committed → Fix Released
Michael Vogt (mvo) wrote :

I added code to update-manager that will remove lilo if both lilo and grub are installed and no lilo.conf is found. I assume this is sufficient or can you think of additional safety checks?

Changed in update-manager:
status: Triaged → Fix Committed
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package update-manager - 1:0.96

---------------
update-manager (1:0.96) jaunty; urgency=low

  * UpdateManager/Core/MetaRelease.py:
    - deal with full disks better when downloading
      the meta-release information (LP: #98666)
  * DistUpgrade/DistUpgradeView.py:
    - make the FuzzyTimeToStr() function not display
      minutes when the total time is > 3h (LP: #144455)
  * build update-manager-text package with text/newt based
    update-manager frontend (update-manager-text)
  * DistUpgrade/DistUpgradeQuirks.py:
    - check if both grub and lilo are installed and remove
      the one that is not used (LP: #314004)
  * po/POTFILES.in, po/POTFILES.skip:
    - updated
  * po/update-manager.pot:
    - refreshed

 -- Michael Vogt <email address hidden> Mon, 12 Jan 2009 14:12:27 +0100

Changed in update-manager:
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.28-4.10

---------------
linux (2.6.28-4.10) jaunty; urgency=low

  [ Andy Whitcroft ]

  * update kernel bootloader recommends: to prefer grub
    - LP: #314004
  * SAUCE: don't use buggy _BCL/_BCM/_BQC for backlight control
    - LP: #311716
  * SAUCE: test-suspend -- add the suspend test scripts
    - LP: #316419

  [ Colin Watson ]

  * Enable udebs for armel

  [ Tim Gardner ]

  * SAUCE: Dell laptop digital mic does not work, PCI 1028:0271
    - LP: #309508
  * Enable CIFS_XATTR=y and CONFIG_CIFS_POSIX=y
    - LP: #220658

 -- Tim Gardner <email address hidden> Thu, 08 Jan 2009 10:38:22 -0700

Changed in linux:
status: Fix Committed → Fix Released
Jeremy Bicha (jbicha) wrote :

This fix will be applied back to Intrepid, right?

On Fri, Jan 16, 2009 at 05:17:10AM -0000, Jeremy Bicha wrote:
> This fix will be applied back to Intrepid, right?

The kernel part is performance optimisation during the common install
case, indeed all of the changes here are fixes for the installer as the
problem occurs at install time not later. There would only be any point
in back porting if any new Intrepid ISOs were to be made and I do not
believe there are at this stage. In short no I am not expecting this to
be backported to Intrepid.

Colin Watson (cjwatson) wrote :

Release notes text added:

 * Ubuntu 8.10 systems installed from the desktop CD mistakenly had the lilo package installed as well as grub, although grub was used for booting. If you use the recommended Update Manager upgrade method, then the lilo package will be removed if it does not appear to be used. If you upgrade using some other method and are sure that you only use the GRUB boot loader, then we recommend that you remove the lilo package manually. Bug:314004

Changed in ubuntu-release-notes:
assignee: nobody → cjwatson
status: New → Fix Committed
Colin Watson (cjwatson) wrote :

s/Release notes/Technical overview errata/

Colin Watson (cjwatson) wrote :

I've migrated the text from the technical overview to the release notes for 9.04.

Changed in ubuntu-release-notes:
status: Fix Committed → Fix Released
John Watts (john-watts) wrote :

I just upgraded and I think I've been affected by this bug. I installed 8.10 from the live CD and upgraded yesterday via update manager. I was using the defualt GRUB in 8.10 and got a notification about configuring lilo during the upgrade. Now when I look at Synaptic I can see that lilo is installed. What other information should I provide?

I just upgraded 2 July 2009 (yesterday). I never used Lilo. Today it was included in the upgrade (I should have unchecked it, but did not). When I clicked cancel in the pop up window (informing me that it is essential that I run lilo config) it was ignored until the third time, when I received a crash error.

One pop-up: E: lilo: subprocess post-installation script returned error exit status 1

Quote from upgrade is complete window , details:

   Errors were encountered while processing:
    lilo
   E: Sub-process /usr/bin/dpkg returned an error code (1)
   A package failed to install. Trying to recover:
   Setting up lilo (1:22.8-7ubuntu1) ...
   dpkg: error processing lilo (--configure):
   subprocess post-installation script returned error exit status 1
   Errors were encountered while processing:
    lilo

Linux Release
-------------
DISTRIB_ID=Ubuntu
DISTRIB_RELEASE=9.04
DISTRIB_CODENAME=jaunty
DISTRIB_DESCRIPTION="Ubuntu 9.04"
-------------
Linux version
Linux 2.6.27-14-generic #1 SMP Tue Jun 30 19:54:46 UTC 2009 x86_64 GNU/Linux
-------------

I have removed it using Synaptec. I hope Grub is unaffected.

IzzieDee

Changed in linux (Ubuntu):
assignee: Andy Whitcroft (apw) → gatoseco94@hotmail.com (gatoseco94)
Steve Langasek (vorlon) on 2009-08-13
Changed in linux (Ubuntu):
assignee: gatoseco94@hotmail.com (gatoseco94) → Andy Whitcroft (apw)
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers